<?

function LoadPng ($imgname, $w = 120, $h = 20) {
 $phpV = substr(phpversion(),0,1);
 
 if ($w <= 0) $w = 120;
 if ($h <= 0) $h = 20;
 
 if ($phpV >= 4) $check = (@imageTypes() & IMG_PNG);
 
 else $check = true; 
 if ($check) {
 
 $im = @ImageCreateFromPng ($imgname); 
 
 if (!$im) { 
 
 $im = ImageCreate ($w, $h);
 $_bc = ImageColorAllocate($im, 255, 255, 255);
 ImageFilledRectangle ($im, 0, 0, $w, $h, $_bc);
 }
 return $im;
 } else {
 return false;
 }
} 

function &getLanguagedIcon( $module, $baseIcon, $lang, $witdth=20, $height=20 )
{
 global $NODEPATH, $TPL, $FILEPATH;
 
 if (ereg("^[a-zA-Z0-9_\-\/]*[a-zA-Z0-9_\-\.]+\.[a-zA-Z0-9_\-]+$",$baseIcon) &&
 ereg("^[a-zA-Z0-9_\-\/]*[a-zA-Z0-9_\-\.]+$",$module) &&
 !ereg("\.\.", $baseIcon) ) {
 $filename = "$NODEPATH/modules/$module/template/$TPL/images/$baseIcon";
 if (!file_exists($filename)) $filename = "";
 }
 else $filename = "";
 if (!$filename) $filename = "$NODEPATH/modules/system/template/$TPL/images/null.gif";
 $lang = "$FILEPATH/languages/$lang.gif";
 if ($im = LoadPng($filename, $w, $h)) {
 if (file_exists($lang)) {
 $resizer = new img_resize( $lang );
 $im_icon = $resizer->getImageHandle();
 if ($im_icon) {
 
 
 
 
 $resizer->setProp("maxwidth",16);
 $resizer->setProp("maxheight",9);
 imagecopy ($im, $im_icon, 0, (16-$resizer->imgheight), 0, 0, $resizer->imgwidth, $resizer->imgheight);
 }
 }
 return $im;
 } else {
 return false;
 }
}

function get_langicon( $base, $code, $module="" )
{
 global $MODULE, $SID, $STAG_PREFIX;
 if ( !$module ) $module = $MODULE;
 return "$STAG_PREFIX?sid=$SID&do=14203&base=".$base."&lang=$code&module=$module";
}




function img($img, $border=0, $alt="", $name="", $width="", $height="", $align="", $style="", $class=NULL, $style=NULL, $onclick=NULL) {
 global $STAG_PREFIX;

 if (!$img) $img = "$STAG_PREFIX?do=11&module=system&img=null.gif";

 $ret = "<img src=\"$img\" border=\"$border\"";
 $ret .= " alt=\"$alt\"";
 if ( $alt ) $ret .= " title=\"$alt\"";
 if ($name) $ret .= " name=\"$name\"";
 if ($width) $ret .= " width=\"$width\"";
 if ($height) $ret .= " height=\"$height\"";
 if ($align) $ret .= " align=\"$align\"";
 if ($style) $ret .= " style=\"$style\"";
 if ($class !== NULL) $ret .= " class=\"$class\"";
 if ($style !== NULL) $ret .= " style=\"$style\"";
 if ($onclick !== NULL) {
 $ret .= " onclick=\"$onclick\"";
 }
 $ret .= ">";
 return $ret;
}



function get_img_path($img) {
 global $TPL, $NODEPATH;
 parse_str(str_replace("?", "&", $img), $arr);
 return "$NODEPATH/modules/".$arr["module"]."/template/$TPL/images/".$arr["img"];
}

function get_img_info_from_url( $imgUrl )
{
 global $TPL, $NODEPATH;
 parse_str(str_replace("?", "&", $imgUrl), $arr);
 if ( in_array($arr["do"], array( 11, 12, 13) ) || !$arr["do"] ) 
 {
 return array( "path"=>"$NODEPATH/modules/".$arr["module"]."/template/$TPL/images/".$arr["img"] ); 
 }
 else if ( $arr["do"] == 14203 ) 
 {
 return array( "resource"=>getLanguagedIcon( $arr["module"], $arr["base"], $arr["lang"]) );
 } 
 else return false;
}

?>
