<?

global $DIC,$REGEX,$REG,$USER_REG,$USER_REGEX;

$USER_REG = array();
$USER_REGEX = array();

function get_user_regs() {
 global $LANGUAGE,$USER_REG,$USER_REGEX,$SQLAS;

 
 $sql = "SELECT regex.id, regex.regex, n_dic.value as name, d_dic.value as descr FROM dicuser $SQLAS n_dic, dicuser $SQLAS d_dic, regex WHERE (regex.name_id = n_dic.output_id AND n_dic.language_id = ".sqlf_tl_num($LANGUAGE).") AND (regex.desc_id = d_dic.output_id AND d_dic.language_id = ".sqlf_tl_num($LANGUAGE).")";

 $rs = query($sql);

 if ($rs["arr"]) {
 while (list($key,$row) = each($rs["arr"])) {
 $USER_REG[$row["id"]]["exp"] = $row["regex"];
 $USER_REGEX[$row["id"]] = $row["regex"];
 $USER_REG[$row["id"]]["name"] = $row["name"];
 $USER_REG[$row["id"]]["desc"] = $row["descr"];
 }
 }
 return $USER_REG;
}

function get_regex_by_id($regex_id) {
 $sql = "SELECT regex from regex where id = ".sqlf_tl_num($regex_id);

 $rs = query($sql);
 return $rs['arr'][0]['regex'];
}

function get_regex_description($regex_id) {
 global $LANGUAGE;

 $sql = "SELECT d1.value name, d2.value description
          FROM regex
          LEFT JOIN dicuser d1 ON d1.output_id = regex.name_id AND d1.language_id = ".sqlf_tl_num($LANGUAGE)."
          LEFT JOIN dicuser d2 ON d2.output_id = regex.desc_id AND d2.language_id = ".sqlf_tl_num($LANGUAGE)."
          WHERE regex.id = ".sqlf_tl_num($regex_id);

 $rs = query($sql);
 $ret = $rs['arr'][0]['name'].": ".$rs['arr'][0]['description'];
 return $ret;
}


$REGEX = array();
$REG = array();


define( "REG_INTEGER", 1 );
$REGEX[REG_INTEGER] = "^[1-9][0-9]{0,8}$";
$REG[REG_INTEGER]["exp"] = $REGEX[REG_INTEGER];
$REG[REG_INTEGER]["name"] = i18n('number_natural');
$REG[REG_INTEGER]["desc"] = i18n('natrliche_zahl_maximal');

define( "REG_EMAIL", 4 );
$REGEX[REG_EMAIL] = "^([-_.&0-9a-zA-Z\+])+@[0-9a-z]([-.]?[0-9a-z])*.[a-z]{2,}$";
$REG[REG_EMAIL]["exp"] = $REGEX[REG_EMAIL];
$REG[REG_EMAIL]["name"] = i18n('email_address');
$REG[REG_EMAIL]["desc"] = i18n('email_adressebeispiel');

define( "REG_NOTEMPTY", 5 );
$REGEX[REG_NOTEMPTY] = ".+";
$REG[REG_NOTEMPTY]["exp"] = $REGEX[REG_NOTEMPTY];
$REG[REG_NOTEMPTY]["name"] = i18n('must_not_be_emty');
$REG[REG_NOTEMPTY]["desc"] = i18n('the_field_must_not_be');

define( "REG_TEXT_SHORT", 8 );
$REGEX[REG_TEXT_SHORT] = "^.{1,255}$";
$REG[REG_TEXT_SHORT]["exp"] = $REGEX[REG_TEXT_SHORT];
$REG[REG_TEXT_SHORT]["name"] = i18n('text_short');
$REG[REG_TEXT_SHORT]["desc"] = i18n('any_text_max._255');

define( "REG_TEXT", 9 );
$REGEX[REG_TEXT] = "";
$REG[REG_TEXT]["exp"] = "";
$REG[REG_TEXT]["name"] = i18n('text_long');
$REG[REG_TEXT]["desc"] = i18n('any_text_any_length');

define( "REG_FLOAT", 10 );
$REGEX[REG_FLOAT] = "^[-+]{0,1}[0-9]{1,9}.{0,1}[0-9]{0,2}$";
$REG[REG_FLOAT]["exp"] = $REGEX[REG_FLOAT];
$REG[REG_FLOAT]["name"] = i18n('number_real');
$REG[REG_FLOAT]["desc"] = i18n('reelle_zahl_max_9_vor');

define( "REG_TEXT_SIMPLE", 11 );
$REGEX[REG_TEXT_SIMPLE] = "^[ßäöüÄÖÜa-zA-Z .-]{1,50}$";
$REG[REG_TEXT_SIMPLE]["exp"] = $REGEX[REG_TEXT_SIMPLE];
$REG[REG_TEXT_SIMPLE]["name"] = i18n('text_simple');
$REG[REG_TEXT_SIMPLE]["desc"] = i18n('text_mit_max._50_lnge');

define( "REG_LONG", 12 );
$REGEX[REG_LONG] = "^[+-]{0,1}[0-9]{1,9}$";
$REG[REG_LONG]["exp"] = $REGEX[REG_LONG];
$REG[REG_LONG]["name"] = i18n('number_integer');
$REG[REG_LONG]["desc"] = i18n('ganze_zahl_max._9');
global $CUSTOM_LOGIN_REGEX;

define( "REG_TEXT_RESTRICTED", 13 );
if (is_array($CUSTOM_LOGIN_REGEX)) {
 $REG[REG_TEXT_RESTRICTED] = $CUSTOM_LOGIN_REGEX;
 if (!$REG[13]["name"]) $REG[13]["name"] = i18n('text_username_password');
} else {
 $REG[REG_TEXT_RESTRICTED]["exp"] = "^[a-zA-Z0-9\._@\+\-]{4,40}$";
 $REG[REG_TEXT_RESTRICTED]["name"] = i18n('text_username_password');
 $REG[REG_TEXT_RESTRICTED]["desc"] = i18n('nur_buchstaben_oder');
}
$REGEX[13] = $REG[13]["exp"];

global $CUSTOM_PASSWORD_REGEX;
define( "REG_TEXT_PASSWORD", 14 );
if (is_array($CUSTOM_PASSWORD_REGEX)) {
 $REG[REG_TEXT_PASSWORD] = $CUSTOM_PASSWORD_REGEX;
 if (!$REG[REG_TEXT_PASSWORD]["name"]) $REG[REG_TEXT_PASSWORD]["name"] = i18n('text_username_password');
} else {
 $REG[REG_TEXT_PASSWORD]["exp"] = "^[a-zA-Z0-9\._@\+\-]{4,40}$";
 $REG[REG_TEXT_PASSWORD]["name"] = i18n('text_username_password');
 $REG[REG_TEXT_PASSWORD]["desc"] = i18n('nur_buchstaben_oder');
}
$REGEX[REG_TEXT_PASSWORD] = $REG[REG_TEXT_PASSWORD]["exp"];

define( "REG_URL", 15 );
$REGEX[REG_URL] = ".+";
$REG[REG_URL]["exp"] = $REGEX[REG_URL];
$REG[REG_URL]["name"] = i18n('www_address');
$REG[REG_URL]["desc"] = i18n('desc_webaddress');

$REGEX[16] = "^[a-zA-Z0-9\._-]{1,64}$";
$REG[16]["exp"] = $REGEX[16];



define( "REG_FOLDERNAME", 17 );
$REGEX[REG_FOLDERNAME] = "^[0-9ßäöüÄÖÜa-zA-Z \.-]{1,255}$";
$REG[REG_FOLDERNAME]["exp"] = $REGEX[REG_FOLDERNAME];
$REG[REG_FOLDERNAME]["name"] = i18n('foldername');
$REG[REG_FOLDERNAME]["desc"] = i18n('text_mit_max._255_lnge');


define( "REG_FILENAME", 18 );

$REGEX[REG_FILENAME] = "^(.){0,64}$";
$REG[REG_FILENAME]["exp"] = $REGEX[REG_FILENAME];
$REG[REG_FILENAME]["name"] = i18n('1148.filename');
$REG[REG_FILENAME]["desc"] = i18n('invalid_filename');


define( "REG_DATE", 19 );
$REGEX[REG_DATE] = "^([0-9]{1,2})[.,_/ -]([0-9]{1,2})[.,_/ -]([0-9]{2}|[0-9]{4})$";
$REG[REG_DATE]["exp"] = $REGEX[REG_DATE];
$REG[REG_DATE]["name"] = i18n('date_fix');
$REG[REG_DATE]["desc"] = i18n('datum_im_format_dd.mm.yyyy_oder_dd.mm.yy_mit_den_trennzeichen_.__und_leerzeichen');

define( "REG_TIME", 20 );
$REGEX[REG_TIME] = "^([0-9]{1,2}):([0-9]{1,2})$";
$REG[REG_TIME]["exp"] = $REGEX[REG_TIME];
$REG[REG_TIME]["name"] = i18n('time_fix');
$REG[REG_TIME]["desc"] = i18n('uhrzeit_im_format');

define( "REG_TIME_ALT", 21 );
$REGEX[REG_TIME_ALT] = "^([0-1]?[0-9]|2[0-3])(:([0-5]?[0-9])|())$";
$REG[REG_TIME_ALT]["exp"] = $REGEX[REG_TIME_ALT];
$REG[REG_TIME_ALT]["name"] = i18n('time_alternative');
$REG[REG_TIME_ALT]["desc"] = i18n('uhrzeit_im_format_hhmm');

define( "REG_SHORT", 22 );
$REGEX[REG_SHORT] = "^[1-5]{0,1}[0-9]$";
$REG[REG_SHORT]["exp"] = $REGEX[REG_SHORT];
$REG[REG_SHORT]["name"] = i18n('number_natural_small');
$REG[REG_SHORT]["desc"] = i18n('natrliche_zahl_kleiner');

define( "REG_DATE_ALT", 23 );
$REGEX[REG_DATE_ALT] = "^([0-2]?[0-9]|3[0-1])([.:_ /-]([0]?[0-9]|1[0-2])([.:_ /-]([0-9]{1,2}|[0-9]{4})|[.:_ /-]|())|[.:_ /-]|())$";
$REG[REG_DATE_ALT]["exp"] = $REGEX[REG_DATE_ALT];
$REG[REG_DATE_ALT]["name"] = i18n('date_alternative');
$REG[REG_DATE_ALT]["desc"] = i18n('datum_im_format_tt.mm.jjjj_oder_tt.mm.jj');

define( "REG_PATH", 24 );
$REGEX[REG_PATH] = "^/{0,1}([a-zA-Z0-9\._-]{1,64}/{0,1}){0,127}$";
$REG[REG_PATH]["exp"] = $REGEX[REG_PATH];
$REG[REG_PATH]["name"] = i18n('directory_path');
$REG[REG_PATH]["desc"] = i18n('verzeichnispfad_unix');

define( "REG_HOSTNAME", 25 );
$REGEX[REG_HOSTNAME] = "^[0-9a-z]([-.]?[0-9a-z:])*$";
$REG[REG_HOSTNAME]["exp"] = $REGEX[REG_HOSTNAME];
$REG[REG_HOSTNAME]["name"] = i18n('hostname');
$REG[REG_HOSTNAME]["desc"] = i18n('domne_oder_ip_adresse.zb_www.gentics.com');

define( "REG_TEXT_UNIQUE", 26 );
$REGEX[REG_TEXT_UNIQUE] = "^[a-z0-9]{3,64}$";
$REG[REG_TEXT_UNIQUE]["exp"] = $REGEX[REG_TEXT_UNIQUE];
$REG[REG_TEXT_UNIQUE]["name"] = i18n('text_unique');
$REG[REG_TEXT_UNIQUE]["desc"] = i18n('nur_kleinbuchstaben_ohne');

define( "REG_PLZ", 27 );
$REGEX[REG_PLZ] = "[A-Z]{0,2}[\-]{0,1}[0-9]{4,6}";
$REG[REG_PLZ]["exp"] = $REGEX[REG_PLZ];
$REG[REG_PLZ]["name"] = i18n('1166.zip_code');


define( "REG_PHONE", 28 );
$REGEX[REG_PHONE] = "^[0-9\-\/ \+\(\)]{4,25}$";
$REG[REG_PHONE]["exp"] = $REGEX[REG_PHONE];
$REG[REG_PHONE]["name"] = i18n('telefonfaxnummer');
$REG[REG_PHONE]["desc"] = i18n('telefonfaxnummer425');

define( "REG_PRICE", 29 );
$REGEX[REG_PRICE] = "^[0-9]{1,12}.{0,1}[0-9]{0,2}$";
$REG[REG_PRICE]["exp"] = $REGEX[REG_PRICE];
$REG[REG_PRICE]["name"] = i18n('preis_sn');
$REG[REG_PRICE]["desc"] = i18n('preis_max_12_vorkommastellen_und_2_nachkommastellen');

define( "REG_FILESHARE", 30 );
$REGEX[REG_FILESHARE] = "^\\\\.*$";
$REG[REG_FILESHARE]["exp"] = $REGEX[REG_FILESHARE];
$REG[REG_FILESHARE]["name"] = i18n('fileshare');
$REG[REG_FILESHARE]["desc"] = i18n('gltiger_fileshare_pfad');

define( "REG_NODETAG", 31 );
$REGEX[REG_NODETAG] = "^[a-zA-Z0-9\_\-]{3,255}$";
$REG[REG_NODETAG]["exp"] = $REGEX[REG_NODETAG];
$REG[REG_NODETAG]["name"] = i18n('1173.node_tag');
$REG[REG_NODETAG]["desc"] = i18n('nur_buchstaben_bindestrich_und_unterstrich._3_bis_255_zeichen');


$REGEX[40] = "(?:http://(?:(?:(?:(?:(?:[a-zA-Z\d](?:(?:[a-zA-Z\d]|-)*[a-zA-Z\d])?)\.)*(?:[a-zA-Z](?:(?:[a-zA-Z\d]|-)*[a-zA-Z\d])?))|(?:(?:\d+)(?:\.(?:\d+)){3}))(?::(?:\d+))?)(?:/(?:(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[;:@&=])*)(?:/(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[;:@&=])*))*)(?:\?(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[;:@&=])*))?)?)|(?:ftp://(?:(?:(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[;?&=])*)(?::(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[;?&=])*))?@)?(?:(?:(?:(?:(?:[a-zA-Z\d](?:(?:[a-zA-Z\d]|-)*[a-zA-Z\d])?)\.)*(?:[a-zA-Z](?:(?:[a-zA-Z\d]|-)*[a-zA-Z\d])?))|(?:(?:\d+)(?:\.(?:\d+)){3}))(?::(?:\d+))?))(?:/(?:(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[?:@&=])*)(?:/(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[?:@&=])*))*)(?:;type=[AIDaid])?)?)|(?:news:(?:(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[;/?:&=])+@(?:(?:(?:(?:[a-zA-Z\d](?:(?:[a-zA-Z\d]|-)*[a-zA-Z\d])?)\.)*(?:[a-zA-Z](?:(?:[a-zA-Z\d]|-)*[a-zA-Z\d])?))|(?:(?:\d+)(?:\.(?:\d+)){3})))|(?:[a-zA-Z](?:[a-zA-Z\d]|[_.+-])*)|\*))|(?:nntp://(?:(?:(?:(?:(?:[a-zA-Z\d](?:(?:[a-zA-Z\d]|-)*[a-zA-Z\d])?)\.)*(?:[a-zA-Z](?:(?:[a-zA-Z\d]|-)*[a-zA-Z\d])?))|(?:(?:\d+)(?:\.(?:\d+)){3}))(?::(?:\d+))?)/(?:[a-zA-Z](?:[a-zA-Z\d]|[_.+-])*)(?:/(?:\d+))?)|(?:telnet://(?:(?:(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[;?&=])*)(?::(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[;?&=])*))?@)?(?:(?:(?:(?:(?:[a-zA-Z\d](?:(?:[a-zA-Z\d]|-)*[a-zA-Z\d])?)\.)*(?:[a-zA-Z](?:(?:[a-zA-Z\d]|-)*[a-zA-Z\d])?))|(?:(?:\d+)(?:\.(?:\d+)){3}))(?::(?:\d+))?))/?)|(?:gopher://(?:(?:(?:(?:(?:[a-zA-Z\d](?:(?:[a-zA-Z\d]|-)*[a-zA-Z\d])?)\.)*(?:[a-zA-Z](?:(?:[a-zA-Z\d]|-)*[a-zA-Z\d])?))|(?:(?:\d+)(?:\.(?:\d+)){3}))(?::(?:\d+))?)(?:/(?:[a-zA-Z\d$\-_.+!*'(),;/?:@&=]|(?:%[a-fA-F\d]{2}))(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),;/?:@&=]|(?:%[a-fA-F\d]{2}))*)(?:%09(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[;:@&=])*)(?:%09(?:(?:[a-zA-Z\d$\-_.+!*'(),;/?:@&=]|(?:%[a-fA-F\d]{2}))*))?)?)?)?)|(?:wais://(?:(?:(?:(?:(?:[a-zA-Z\d](?:(?:[a-zA-Z\d]|-)*[a-zA-Z\d])?)\.)*(?:[a-zA-Z](?:(?:[a-zA-Z\d]|-)*[a-zA-Z\d])?))|(?:(?:\d+)(?:\.(?:\d+)){3}))(?::(?:\d+))?)/(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))*)(?:(?:/(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))*)/(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))*))|\?(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[;:@&=])*))?)|(?:mailto:(?:(?:[a-zA-Z\d$\-_.+!*'(),;/?:@&=]|(?:%[a-fA-F\d]{2}))+))|(?:file://(?:(?:(?:(?:(?:[a-zA-Z\d](?:(?:[a-zA-Z\d]|-)*[a-zA-Z\d])?)\.)*(?:[a-zA-Z](?:(?:[a-zA-Z\d]|-)*[a-zA-Z\d])?))|(?:(?:\d+)(?:\.(?:\d+)){3}))|localhost)?/(?:(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[?:@&=])*)(?:/(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[?:@&=])*))*))|(?:prospero://(?:(?:(?:(?:(?:[a-zA-Z\d](?:(?:[a-zA-Z\d]|-)*[a-zA-Z\d])?)\.)*(?:[a-zA-Z](?:(?:[a-zA-Z\d]|-)*[a-zA-Z\d])?))|(?:(?:\d+)(?:\.(?:\d+)){3}))(?::(?:\d+))?)/(?:(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[?:@&=])*)(?:/(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[?:@&=])*))*)(?:(?:;(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[?:@&])*)=(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[?:@&])*)))*)|(?:ldap://(?:(?:(?:(?:(?:(?:[a-zA-Z\d](?:(?:[a-zA-Z\d]|-)*[a-zA-Z\d])?)\.)*(?:[a-zA-Z](?:(?:[a-zA-Z\d]|-)*[a-zA-Z\d])?))|(?:(?:\d+)(?:\.(?:\d+)){3}))(?::(?:\d+))?))?/(?:(?:(?:(?:(?:(?:(?:[a-zA-Z\d]|%(?:3\d|[46][a-fA-F\d]|[57][Aa\d]))|(?:%20))+|(?:OID|oid)\.(?:(?:\d+)(?:\.(?:\d+))*))(?:(?:%0[Aa])?(?:%20)*)=(?:(?:%0[Aa])?(?:%20)*))?(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))*))(?:(?:(?:%0[Aa])?(?:%20)*)\+(?:(?:%0[Aa])?(?:%20)*)(?:(?:(?:(?:(?:[a-zA-Z\d]|%(?:3\d|[46][a-fA-F\d]|[57][Aa\d]))|(?:%20))+|(?:OID|oid)\.(?:(?:\d+)(?:\.(?:\d+))*))(?:(?:%0[Aa])?(?:%20)*)=(?:(?:%0[Aa])?(?:%20)*))?(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))*)))*)(?:(?:(?:(?:%0[Aa])?(?:%20)*)(?:[;,])(?:(?:%0[Aa])?(?:%20)*))(?:(?:(?:(?:(?:(?:[a-zA-Z\d]|%(?:3\d|[46][a-fA-F\d]|[57][Aa\d]))|(?:%20))+|(?:OID|oid)\.(?:(?:\d+)(?:\.(?:\d+))*))(?:(?:%0[Aa])?(?:%20)*)=(?:(?:%0[Aa])?(?:%20)*))?(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))*))(?:(?:(?:%0[Aa])?(?:%20)*)\+(?:(?:%0[Aa])?(?:%20)*)(?:(?:(?:(?:(?:[a-zA-Z\d]|%(?:3\d|[46][a-fA-F\d]|[57][Aa\d]))|(?:%20))+|(?:OID|oid)\.(?:(?:\d+)(?:\.(?:\d+))*))(?:(?:%0[Aa])?(?:%20)*)=(?:(?:%0[Aa])?(?:%20)*))?(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))*)))*))*(?:(?:(?:%0[Aa])?(?:%20)*)(?:[;,])(?:(?:%0[Aa])?(?:%20)*))?)(?:\?(?:(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))+)(?:,(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))+))*)?)(?:\?(?:base|one|sub)(?:\?(?:((?:[a-zA-Z\d$\-_.+!*'(),;/?:@&=]|(?:%[a-fA-F\d]{2}))+)))?)?)?)|(?:(?:z39\.50[rs])://(?:(?:(?:(?:(?:[a-zA-Z\d](?:(?:[a-zA-Z\d]|-)*[a-zA-Z\d])?)\.)*(?:[a-zA-Z](?:(?:[a-zA-Z\d]|-)*[a-zA-Z\d])?))|(?:(?:\d+)(?:\.(?:\d+)){3}))(?::(?:\d+))?)(?:/(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))+)(?:\+(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))+))*(?:\?(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))+))?)?(?:;esn=(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))+))?(?:;rs=(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))+)(?:\+(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))+))*)?))|(?:cid:(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[;?:@&=])*))|(?:mid:(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[;?:@&=])*)(?:/(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[;?:@&=])*))?)|(?:vemmi://(?:(?:(?:(?:(?:[a-zA-Z\d](?:(?:[a-zA-Z\d]|-)*[a-zA-Z\d])?)\.)*(?:[a-zA-Z](?:(?:[a-zA-Z\d]|-)*[a-zA-Z\d])?))|(?:(?:\d+)(?:\.(?:\d+)){3}))(?::(?:\d+))?)(?:/(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[/?:@&=])*)(?:(?:;(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[/?:@&])*)=(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[/?:@&])*))*))?)|(?:imap://(?:(?:(?:(?:(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[&=~])+)(?:(?:;[Aa][Uu][Tt][Hh]=(?:\*|(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[&=~])+))))?)|(?:(?:;[Aa][Uu][Tt][Hh]=(?:\*|(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[&=~])+)))(?:(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[&=~])+))?))@)?(?:(?:(?:(?:(?:[a-zA-Z\d](?:(?:[a-zA-Z\d]|-)*[a-zA-Z\d])?)\.)*(?:[a-zA-Z](?:(?:[a-zA-Z\d]|-)*[a-zA-Z\d])?))|(?:(?:\d+)(?:\.(?:\d+)){3}))(?::(?:\d+))?))/(?:(?:(?:(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[&=~:@/])+)?;[Tt][Yy][Pp][Ee]=(?:[Ll](?:[Ii][Ss][Tt]|[Ss][Uu][Bb])))|(?:(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[&=~:@/])+)(?:\?(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[&=~:@/])+))?(?:(?:;[Uu][Ii][Dd][Vv][Aa][Ll][Ii][Dd][Ii][Tt][Yy]=(?:[1-9]\d*)))?)|(?:(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[&=~:@/])+)(?:(?:;[Uu][Ii][Dd][Vv][Aa][Ll][Ii][Dd][Ii][Tt][Yy]=(?:[1-9]\d*)))?(?:/;[Uu][Ii][Dd]=(?:[1-9]\d*))(?:(?:/;[Ss][Ee][Cc][Tt][Ii][Oo][Nn]=(?:(?:(?:[a-zA-Z\d$\-_.+!*'(),]|(?:%[a-fA-F\d]{2}))|[&=~:@/])+)))?)))?)|(?:nfs:(?:(?://(?:(?:(?:(?:(?:[a-zA-Z\d](?:(?:[a-zA-Z\d]|-)*[a-zA-Z\d])?)\.)*(?:[a-zA-Z](?:(?:[a-zA-Z\d]|-)*[a-zA-Z\d])?))|(?:(?:\d+)(?:\.(?:\d+)){3}))(?::(?:\d+))?)(?:(?:/(?:(?:(?:(?:(?:[a-zA-Z\d\$\-_.!~*'(),])|(?:%[a-fA-F\d]{2})|[:@&=+])*)(?:/(?:(?:(?:[a-zA-Z\d\$\-_.!~*'(),])|(?:%[a-fA-F\d]{2})|[:@&=+])*))*)?)))?)|(?:/(?:(?:(?:(?:(?:[a-zA-Z\d\$\-_.!~*'(),])|(?:%[a-fA-F\d]{2})|[:@&=+])*)(?:/(?:(?:(?:[a-zA-Z\d\$\-_.!~*'(),])|(?:%[a-fA-F\d]{2})|[:@&=+])*))*)?))|(?:(?:(?:(?:(?:[a-zA-Z\d\$\-_.!~*'(),])|(?:%[a-fA-F\d]{2})|[:@&=+])*)(?:/(?:(?:(?:[a-zA-Z\d\$\-_.!~*'(),])|(?:%[a-fA-F\d]{2})|[:@&=+])*))*)?)))";
$REG[40]["exp"] = $REGEX[40];
$REG[40]["name"] = "URLs";
$REG[40]["desc"] = "";

define( "REG_SHORT0", 41 );
$REGEX[REG_SHORT0] = "^[0-5]{0,1}[0-9]$";
$REG[REG_SHORT0]["exp"] = $REGEX[REG_SHORT0];
$REG[REG_SHORT0]["name"] = i18n('number_natural_small');
$REG[REG_SHORT0]["desc"] = i18n('Natürliche Zahl inklusive 0 und kleiner 60. Beispiel: 42');

define( "REG_SHORT0_VOID", 42 );
$REGEX[REG_SHORT0_VOID] = "^([0-5]{0,1}[0-9])?$";
$REG[REG_SHORT0_VOID]["exp"] = $REGEX[REG_SHORT0_VOID];
$REG[REG_SHORT0_VOID]["name"] = i18n('number_natural_small');
$REG[REG_SHORT0_VOID]["desc"] = i18n('Natürliche Zahl inklusive 0 und kleiner 60. Beispiel: 42');

define( "REG_DATETIME", 43 );
$REGEX[REG_DATETIME] = "^[0-9]{4}-[0-9]{2}-[0-9]{2} [0-9]{2}:[0-9]{2}:[0-9]{2}$";
$REG[REG_DATETIME]["exp"] = $REGEX[REG_DATETIME];
$REG[REG_DATETIME]["name"] = i18n("reg_datetime");
$REG[REG_DATETIME]["desc"] = i18n("reg_datetime");

define( "REG_KEYWORD", 44 );
$REGEX[REG_KEYWORD] = "^[a-z0-9_]{3,64}$";
$REG[REG_KEYWORD]["exp"] = $REGEX[REG_KEYWORD];
$REG[REG_KEYWORD]["name"] = i18n("validation.description.tagtype.keyword");
$REG[REG_KEYWORD]["desc"] = i18n("validation.invalid.tagtype.keyword");


define( "REG_PAGEFILENAME", 45 );
$REGEX[REG_PAGEFILENAME] = "^([a-zA-Z0-9\._-]){0,64}$";
$REG[REG_PAGEFILENAME]["exp"] = $REGEX[REG_PAGEFILENAME];
$REG[REG_PAGEFILENAME]["name"] = i18n('1148.filename');
$REG[REG_PAGEFILENAME]["desc"] = i18n('invalid_filename');

?>
